using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Media;
using System.Globalization;
using System.Windows.Controls;

namespace DependencyPropertyInWPF_AddOwner
{
  public class SimpleLabel : FrameworkElement
  {
    public static readonly DependencyProperty FontSizeProperty =
      Control.FontSizeProperty.AddOwner(typeof(SimpleLabel));


    public double FontSize
    {
      get { return (double)GetValue(FontSizeProperty); }
      set { SetValue(FontSizeProperty, value); }
    }

    protected override void OnRender(DrawingContext ctx)
    {
      base.OnRender(ctx);

      ctx.DrawRectangle(Brushes.LightBlue, null, new Rect(this.RenderSize));
      FormattedText txt = GetFormattedText();

      ctx.DrawText(txt, new Point(0, 0));
    }
    
    // Grsse des SimpleLabels berechnen.
    // Methode auskommentieren, um Effekt bei der nderung der FontSize zu sehen
    protected override Size MeasureOverride(Size availableSize)
    {
      Size desiredSize = new Size();

      FormattedText txt = GetFormattedText();

      desiredSize.Width = txt.Width;
      desiredSize.Height = txt.Height;
      return desiredSize;
    }

    private FormattedText GetFormattedText()
    {

      FormattedText txt =
        new FormattedText("SimpleLabel (Click to animate)\nFontSize: " + string.Format("{0:0.0}", FontSize)
          , CultureInfo.CurrentCulture
          , FlowDirection.LeftToRight
          , new Typeface("Arial")
          , this.FontSize,
          Brushes.Black);
      return txt;
    }
  }
}
