using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Media;
using System.Globalization;

namespace DependencyPropertyInWPF_SimpleLabel
{
public class SimpleLabel:FrameworkElement
{
  public static readonly DependencyProperty FontSizeProperty;
  static SimpleLabel()
  {
    FrameworkPropertyMetadata meta =
      new FrameworkPropertyMetadata();
    new FrameworkPropertyMetadata(11.0, FrameworkPropertyMetadataOptions.AffectsRender|FrameworkPropertyMetadataOptions.AffectsMeasure);
    meta.DefaultValue = 11.0; // oder alternativ: SystemFonts.MessageFontSize;
    meta.AffectsRender = true;

    meta.CoerceValueCallback = new CoerceValueCallback(CoerceFontSize);
    meta.PropertyChangedCallback = new PropertyChangedCallback(FontSizeChanged);

    FontSizeProperty =
      DependencyProperty.Register("FontSize"
                                 , typeof(double)
                                 , typeof(SimpleLabel)
                                 , meta
                                 , new ValidateValueCallback(ValidateFontSize));
  }
  private static void FontSizeChanged(DependencyObject depOb, DependencyPropertyChangedEventArgs e)
  {
    // Hier wird spezifische Logik implementiert,
    // die beim ndern der FontSize noch notwendig ist.
  }
  private static object CoerceFontSize(DependencyObject depOb, object value)
  {
    // Hier wird der Code implementiert,
    // um ggf. einen bestimmten Wert der FontSize zu erzwingen
    return value;
  }

  private static bool ValidateFontSize(object value)
  {
    return (double)value >= 0;
  }

    public double FontSize
    {
      get { return (double)GetValue(FontSizeProperty); }
      set { SetValue(FontSizeProperty, value); }
    }

    protected override void OnRender(DrawingContext ctx)
    {
      base.OnRender(ctx);

      ctx.DrawRectangle(Brushes.LightBlue, null, new Rect(this.RenderSize));

      FormattedText txt =
        new FormattedText("SimpleLabel\nFontSize: " + string.Format("{0:0.0}", FontSize)
          , CultureInfo.CurrentCulture
          , FlowDirection.LeftToRight
          , new Typeface("Arial")
          , this.FontSize,
          Brushes.Black);

      ctx.DrawText(txt,new Point(0,0));
    }
  }
}
